module AfterDo
  module Loader
    describe AfterDo::Loader do
      subject(:loader) { described_class }

      let(:config_path) { '/i/am/a/fake/path/' }
      let(:config) { double(Config, aspects: [aspect]) }
      let(:aspect) { double(:aspect) }

      let(:applier) { instance_double(AspectApplier, apply: nil) }

      describe '.load' do
        subject(:load) { loader.load(config_path) }

        before do
          allow(Config).to receive(:new).and_return(config)
          allow(AspectApplier).to receive(:new).and_return(applier)
        end

        it 'loads config with the right path' do
          expect(Config).to receive(:new).with(config_path)

          load
        end

        it 'applies stuff' do
          expect(AspectApplier).to receive(:new).with(aspect)
          expect(applier).to receive(:apply)

          load
        end
      end
    end
  end
end
